/*
 Envoie un email (texte brut) avec une image attache en pice jointe
 
 Il faut dterminer le type MIME du fichier. fonction?
*/
#include <stdio.h>
#include "TCPsocket.h"
#include "base64.h"

int main(int argc, char *argv[])
{
 init_socket();

 SOCKET sk = connection_TCP("smtp.orange.fr", 25);
 lire(sk);

 char hostname[32];
 char buf[255];
 int i;

 gethostname(hostname, 32);
 i = sprintf(buf,"EHLO %s\n", hostname);
 ecrire(sk, buf, i);
 lire(sk);
 
 i = sprintf(buf, "MAIL FROM: <%s>\n", "kkun@orange.fr");
 ecrire(sk, buf, i);

 i = sprintf(buf, "RCPT TO: <%s>\n", "b.masta@ingeniumconseil.fr"); 
 ecrire(sk, buf, i);

 ecrire(sk, "DATA\n", 5);
lire(sk);

 i = sprintf(buf, "FROM: %s <%s>\n", "bert", "kkun@orange.fr"); 
 ecrire(sk, buf, i);

 i = sprintf(buf, "TO: burt <b.masta@ingeniumconseil.fr>\n"); 
 ecrire(sk, buf, i);

 i = sprintf(buf, "SUBJECT: pice jointe\n"); 
 ecrire(sk, buf, i);

 //prciser la version MIME employe
 i = sprintf(buf, "MIME-Version: 1.0\n");
 ecrire(sk, buf, i);

 i = sprintf(buf,  "CONTENT-TYPE: multipart/mixed;\n"
					"	boundary=\"3b28BOUNDARYALT3b28\"\n");
 ecrire(sk, buf, i);

 i = sprintf(buf, "X-MAILER: bert-1.0\n");
 ecrire(sk, buf, i);

 i = sprintf(buf, "\nThis is a multi-part message in MIME format.\n"
				  "\n"
 				  "--3b28BOUNDARYALT3b28\n");
 ecrire(sk, buf, i);

 //le texte
 i = sprintf(buf,   "Content-Type: text/plain;\n"
 					"\tCharset=\"iso-8859-1\"\n"
					"Content-Transfer-Encoding: 7bit\n\n");
 ecrire(sk, buf, i);

 //message au format texte brut
 envoi_big_paquet(sk, "Ceci est le texte",17, 200);

 ecrire(sk, "\n--3b28BOUNDARYALT3b28\n", 23);


 //la pice jointe
 //char *fich = "173ko.jpg";
 //char *MIME = "image/jpeg";

 char *fich = "img.JPG";
 char *MIME = "image/jpeg";

 //char *fich = "cat_music_2.gif";
 //char *MIME = "image/gif";

 //char *fich = "depannage.zip";
 //char *MIME = "application/zip";

//printf("[%s]\n", fichier);
 i = sprintf(buf,   "Content-Type: %s;\n"
					"	name=\"%s\"\n"
					"Content-Transfer-Encoding: base64\n"
					"Content-Disposition: attachment;\n"
					"	filename=\"%s\"\n\n", MIME, fich, fich);
 ecrire(sk, buf, i);

 //l'image (fichier binaire) est encode en base64
 long len, len2;
 char *s = encode_b64_file(fich, &len);
 //puis wordwrappe  76 chars par ligne
 char *t = bxwrap_to_char(s, len, &len2, 76);
 free(s);
 //envoie l'image au serveur
 envoi_big_paquet(sk, t,len2, 60);
 free(t);
//printf("%ld -> %ld\n", len, len2);

 ecrire(sk, "\n\n--3b28BOUNDARYALT3b28", 23);

 ecrire(sk, "\r\n.\r\n", 5);
lire(sk);

 closesocket(sk);

printf("fin\n");
 getchar();
 return 0;
}

/* ce qui donne:

Return-Path: <kkun@orange.fr>
Delivery-Date: Sun, 30 Mar 2008 17:28:44 +0200
Received: from smtp20.orange.fr (smtp20.orange.fr [80.12.242.27])
	by mx.kundenserver.de (node=mxeu21) with ESMTP (Nemesis)
	id 0ML4Q0-1JfzSc1VJ4-0003T9 for b.masta@ingeniumconseil.fr; Sun, 30 Mar 2008 17:28:44 +0200
Received: from me-wanadoo.net (localhost [127.0.0.1])
	by mwinf2009.orange.fr (SMTP Server) with ESMTP id 2FC3F1C0008D
	for <b.masta@ingeniumconseil.fr>; Sun, 30 Mar 2008 17:28:42 +0200 (CEST)
Received: from andre-qg2jfgoj (AMarseille-151-1-58-53.w82-122.abo.wanadoo.fr [82.122.74.53])
	by mwinf2009.orange.fr (SMTP Server) with ESMTP id 1FE5D1C00085
	for <b.masta@ingeniumconseil.fr>; Sun, 30 Mar 2008 17:28:42 +0200 (CEST)
X-ME-UUID: 20080330152842130.1FE5D1C00085@mwinf2009.orange.fr
From: bert <bert.mas@orange.fr>
To: burt <b.masta@ingeniumconseil.fr>
SUBJECT: pice jointe
MIME-Version: 1.0
CONTENT-TYPE: multipart/mixed;
	boundary="BOUNDARYALT"
X-MAILER: bert-1.0
Message-Id: <20080330152842.1FE5D1C00085@mwinf2009.orange.fr>
Date: Sun, 30 Mar 2008 17:28:42 +0200 (CEST)
Envelope-To: b.masta@ingeniumconseil.fr

This is a multi-part message in MIME format.

--BOUNDARYALT
Content-Type: text/plain;
	Charset="iso-8859-1"
Content-Transfer-Encoding: 7bit

Ceci est le texte
--BOUNDARYALT
Content-Type: image/jpeg;
	name="img.JPG"
Content-Transfer-Encoding: base64
Content-Disposition: attachment
	filename="img.JPG"

/9j/4AAQSkZJRgABAQEAYABgAAD/4QAWRXhpZgAASUkqAAgAAAAAAAAAAAD/2wBDAAgGBgcGBQgH
BwcJCQgKDBQNDAsLDBkSEw8UHRofHh0aHBwgJC4nICIsIxwcKDcpLDAxNDQ0Hyc5PTgyPC4zNDL/
2wBDAQkJCQwLDBgNDRgyIRwhMjIyMjIyMjIyMjIyMjIyMjIyMjIyMjIyMjIyMjIyMjIyMjIyMjIy
MjIyMjIyMjIyMjL/wAARCAAzAC4DASIAAhEBAxEB/8QAHwAAAQUBAQEBAQEAAAAAAAAAAAECAwQF
BgcICQoL/8QAtRAAAgEDAwIEAwUFBAQAAAF9AQIDAAQRBRIhMUEGE1FhByJxFDKBkaEII0KxwRVS
0fAkM2JyggkKFhcYGRolJicoKSo0NTY3ODk6Q0RFRkdISUpTVFVWV1hZWmNkZWZnaGlqc3R1dnd4
eXqDhIWGh4iJipKTlJWWl5iZmqKjpKWmp6ipqrKztLW2t7i5usLDxMXGx8jJytLT1NXW19jZ2uHi
4+Tl5ufo6erx8vP09fb3+Pn6/8QAHwEAAwEBAQEBAQEBAQAAAAAAAAECAwQFBgcICQoL/8QAtREA
AgECBAQDBAcFBAQAAQJ3AAECAxEEBSExBhJBUQdhcRMiMoEIFEKRobHBCSMzUvAVYnLRChYkNOEl
8RcYGRomJygpKjU2Nzg5OkNERUZHSElKU1RVVldYWVpjZGVmZ2hpanN0dXZ3eHl6goOEhYaHiImK
kpOUlZaXmJmaoqOkpaanqKmqsrO0tba3uLm6wsPExcbHyMnK0tPU1dbX2Nna4uPk5ebn6Onq8vP0
9fb3+Pn6/9oADAMBAAIRAxEAPwDxWJWt2aQHjpuUg1ZgkmmYAI77vTNNiZJzsjgVRjJ6npXa+F7R
Gj3GMBiegrmq1OVXaN6NJzdk9CXQvD6SRLJOpDN/CR/Ou/0yzt4LdovJXkcnFYRv4tKcLKjbjwoC
E5/IVa07xM11qJtxbZjyVLqjIyMOzBh+orgbcveZ22UVyo4LxRYx6b4gcW8ZAOZTjsP8ivf/AIca
hPf+D7Zpjny/kRiTll/H3yPwryvXtG/tSe61rMi24gNpbGNcmaViRwOu3LgH68cAmvV/Amntp/h2
KAxhFwpXDZ3DAAP4gA/jXTTe1zkqW1PmLTrXG8Nw+cAAg8fh9a7LRwbRU+lchpszfaUOwBccYHWu
7tY0lhUr6VliG76nXheWx0iCG/iUMuHHRu4qxb6dbJI6rgsysrseSSfXNZtlIIQpZtoHc1W1O6k0
11vrS+MiGZVMAwQSx7nBIHBrCLuzWaR3mg+HtNvrK0eNYvLgkIbapQlxkZIzweW4GMFmOATXdKio
AFUAAYAFc5o1nD5Fo+xPNDmVmRQu4kHk4+v+NdKOgFehTWh5k3qfHGmusg8pmEco+6D3rpNI1gK3
kTnaw4rnLV4VuWQDKAgAsevHOKtaraI1rLcW8pMgKlFGQRWdSKlKz6m1ObjG66HpdlHFdQggowP9
7kVzF8+kt4phtvtkKeXI0UnlIQq8jLMQOuSR/wAB7d+ItNc1a2ZoUvXiGMHdjj9Kms7sxQSlYd7s
4JcAlyeeQfrg8+3pS+ruCY3iFKyR9M/D+Rf+Efii4ZgzfPuzuG44A9gMDiuwFeI/DTxjFp1h9k1H
au+QkXEkm3AOMLgj1z37+2a9ntbpLmEOOCe2QfxB6Ee9aU2rct9jCotbnxlnFmjDhgeo69a0UJMF
uxJJK8miinMqBpz28JSOQxRlyB820Z/OoZQASQOQBg96KKzjsEt2VkuZk1GKVZWDk7SwPUYPB9a9
m+Hc8sTLEjkRTWzSvGeV3h8AgdAcE9OtFFRP4kXD4Gf/2

--BOUNDARYALT

*/
