/*
 Envoie un email (texte brut) avec deux images en pices jointes
 Idalement, grer un tableau d'images

typedef struct
{
 char *fichier;
 char *typeMIME;
} piece_jointe;

piece_jointe pieces[2]={
  {"img.JPG","image/jpeg"},
  {"img2.JPG","image/jpeg"}
};

// et boucler pour envoyer les images au serveur:

void envoi_piece_jointe(SOCKET sk, int n)
{
 char buf[255];
 int i = sprintf(buf,   "Content-Type: %s;\n"
					"	name=\"%s\"\n"
					"Content-Transfer-Encoding: base64\n"
					"Content-Disposition: attachment;\n"
					"	filename=\"%s\"\n\n",
						pieces[n].typeMIME,
						pieces[n].fichier,
						pieces[n].fichier);
 ecrire(sk, buf, i);

 //l'image (fichier binaire) est encode en base64
 long len, len2;
 char *s = encode_b64_file(pieces[n].fichier, &len);
 char *t = bxwrap_to_char(s, len, &len2, 76); //wordwrappe  76 chars par ligne
 free(s);
 //envoie l'image au serveur
 envoi_big_paquet(sk, t,len2, 100);
 free(t);
//printf("%ld -> %ld\n", len, len2);

 ecrire(sk, "\n\n--BOUNDARYALT\n", 16);
}
*/
#include <stdio.h>
#include "TCPsocket.h"
#include "base64.h"

int main(int argc, char *argv[])
{
 init_socket();

 SOCKET sk = connection_TCP("smtp.orange.fr", 25);
 lire(sk);

 char hostname[32];
 char buf[255];
 int i;

 gethostname(hostname, 32);
 i = sprintf(buf,"EHLO %s\n", hostname);
 ecrire(sk, buf, i);
 //lire(sk);

 i = sprintf(buf, "MAIL FROM: <%s>\n", "katmailer@orange.fr");
 ecrire(sk, buf, i);

 i = sprintf(buf, "RCPT TO: <%s>\n", "kkun@ingeniumconseil.fr");
 ecrire(sk, buf, i);

 ecrire(sk, "DATA\n", 5);

 i = sprintf(buf, "FROM: %s <%s>\n", "katmailer", "katmailer@orange.fr");
 ecrire(sk, buf, i);

 i = sprintf(buf, "TO: burt <kkunt@ingeniumconseil.fr>\n");
 ecrire(sk, buf, i);

 i = sprintf(buf, "SUBJECT: pice jointe\n");
 ecrire(sk, buf, i);

 //prciser la version MIME employe
 i = sprintf(buf, "MIME-Version: 1.0\n");
 ecrire(sk, buf, i);

 i = sprintf(buf,  "CONTENT-TYPE: multipart/mixed;\n"
					"	boundary=\"3b28BOUNDARYALT3b28\"\n");
 ecrire(sk, buf, i);

 i = sprintf(buf, "X-MAILER: bert-1.0\n");
 ecrire(sk, buf, i);

 i = sprintf(buf, "\nThis is a multi-part message in MIME format.\n"
				  "\n"
 				  "--3b28BOUNDARYALT3b28\n");
 ecrire(sk, buf, i);

 //le texte
 i = sprintf(buf,   "Content-Type: text/plain;\n"
 					"\tCharset=\"iso-8859-1\"\n"
					"Content-Transfer-Encoding: 7bit\n\n");
 ecrire(sk, buf, i);

 //message au format texte brut
 envoi_big_paquet(sk, "Ceci est le texte",17, 100);

 ecrire(sk, "\n--3b28BOUNDARYALT3b28\n", 23);
lire(sk);

//1e image ---------------------------------------------------------------------

 //la pice jointe
 char *fic = "img.JPG";
 char *MIME = "image/jpeg";

 i = sprintf(buf,   "Content-Type: %s;\n"
					"	name=\"%s\"\n"
					"Content-Transfer-Encoding: base64\n"
					"Content-Disposition: attachment;\n"
					"	filename=\"%s\"\n\n", MIME, fic, fic);
 ecrire(sk, buf, i);
//lire(sk);

 //l'image (fichier binaire) est encode en base64
 long len, len2;
 char *s = encode_b64_file(fic, &len);
 char *t = bxwrap_to_char(s, len, &len2, 76); //wordwrappe  76 chars par ligne
 free(s);
 //envoie l'image au serveur
 envoi_big_paquet(sk, t,len2, 100);
 free(t);
//printf("%ld -> %ld\n", len, len2);

 ecrire(sk, "\n\n--3b28BOUNDARYALT3b28\n", 24);
lire(sk);

//2e image ---------------------------------------------------------------------
 //la pice jointe
 char *f2 = "img2.JPG";
 //char *MIME = "image/jpeg";

 i = sprintf(buf,   "Content-Type: %s;\n"
					"	name=\"%s\"\n"
					"Content-Transfer-Encoding: base64\n"
					"Content-Disposition: attachment;\n"
					"	filename=\"%s\"\n\n", MIME, f2, f2);
 ecrire(sk, buf, i);

 //l'image (fichier binaire) est encode en base64
 //long len, len2;
 s = encode_b64_file(f2, &len);
 t = bxwrap_to_char(s, len, &len2, 76);//wordwrappe  76 chars par ligne
 free(s);
 //envoie l'image au serveur
 envoi_big_paquet(sk, t,len2, 100);
 free(t);
//printf("%ld -> %ld\n", len, len2);

 ecrire(sk, "\n\n--3b28BOUNDARYALT3b28", 23);

 ecrire(sk, "\r\n.\r\n", 5);
//lire(sk);

 closesocket(sk);

puts("fin");
 getchar();
 return 0;
}

/* ce qui donne:

Return-Path: <kkun@ingeniumconseil.fr>
Delivery-Date: Sun, 30 Mar 2008 17:37:54 +0200
Received: from moutng.kundenserver.de (moutng.kundenserver.de [212.227.126.171])
	by mx.kundenserver.de (node=mxeu18) with ESMTP (Nemesis)
	id 0MKxMK-1JfzbV3c1j-00040N for kkun@ingeniumconseil.fr; Sun, 30 Mar 2008 17:37:53 +0200
Received: from andre-qg2jfgoj (AMarseille-151-1-58-53.w82-122.abo.wanadoo.fr [82.122.74.53])
	by mrelayeu.kundenserver.de (node=mrelayeu0) with ESMTP (Nemesis)
	id 0MKwh2-1JfzbU46jS-0007ul; Sun, 30 Mar 2008 17:37:53 +0200
Date: Sun, 30 Mar 2008 17:37:54 +0200
From: Jean Bon <kkun@ingeniumconseil.fr>
To: kkun@ingeniumconseil.fr
Subject: 2
Message-Id: <20080330173754.1ab7121d.ffh@ingeniumconseil.fr>
Organization: Ingenium Conseil
X-Mailer: Sylpheed 2.4.4 (GTK+ 2.10.13; i686-pc-mingw32)
Mime-Version: 1.0
Content-Type: multipart/mixed;
 boundary="Multipart=_Sun__30_Mar_2008_17_37_54_+0200_rnHSPKZ7sh0eKFPA"
X-Provags-ID: V01U2FsdGVkX1+eGhgeJ8lsys5w7WDdTqE4chZWJWuQ1la4h0y
 eBu2BNioY7U1WcGOG40k5dGky67EhYbPVz4ssMl+O3YD9micOG
 yWEx82CXmEA/G/outY+ymEGSAQwctw7goCn3XAv9QQ=
Envelope-To: fhfgh@ingeniumconseil.fr

This is a multi-part message in MIME format.

--Multipart=_Sun__30_Mar_2008_17_37_54_+0200_rnHSPKZ7sh0eKFPA
Content-Type: text/plain; charset=US-ASCII
Content-Transfer-Encoding: 7bit



-- 
fghgh <kkun@ingeniumconseil.fr>

--Multipart=_Sun__30_Mar_2008_17_37_54_+0200_rnHSPKZ7sh0eKFPA
Content-Type: image/jpeg;
 name="img.JPG"
Content-Disposition: attachment;
 filename="img.JPG"
Content-Transfer-Encoding: base64

/9j/4AAQSkZJRgABAQEAYABgAAD/4QAWRXhpZgAASUkqAAgAAAAAAAAAAAD/2wBDAAgGBgcGBQgH
BwcJCQgKDBQNDAsLDBkSEw8UHRofHh0aHBwgJC4nICIsIxwcKDcpLDAxNDQ0Hyc5PTgyPC4zNDL/
2wBDAQkJCQwLDBgNDRgyIRwhMjIyMjIyMjIyMjIyMjIyMjIyMjIyMjIyMjIyMjIyMjIyMjIyMjIy
MjIyMjIyMjIyMjL/wAARCAAzAC4DASIAAhEBAxEB/8QAHwAAAQUBAQEBAQEAAAAAAAAAAAECAwQF
BgcICQoL/8QAtRAAAgEDAwIEAwUFBAQAAAF9AQIDAAQRBRIhMUEGE1FhByJxFDKBkaEII0KxwRVS
0fAkM2JyggkKFhcYGRolJicoKSo0NTY3ODk6Q0RFRkdISUpTVFVWV1hZWmNkZWZnaGlqc3R1dnd4
eXqDhIWGh4iJipKTlJWWl5iZmqKjpKWmp6ipqrKztLW2t7i5usLDxMXGx8jJytLT1NXW19jZ2uHi
4+Tl5ufo6erx8vP09fb3+Pn6/8QAHwEAAwEBAQEBAQEBAQAAAAAAAAECAwQFBgcICQoL/8QAtREA
AgECBAQDBAcFBAQAAQJ3AAECAxEEBSExBhJBUQdhcRMiMoEIFEKRobHBCSMzUvAVYnLRChYkNOEl
8RcYGRomJygpKjU2Nzg5OkNERUZHSElKU1RVVldYWVpjZGVmZ2hpanN0dXZ3eHl6goOEhYaHiImK
kpOUlZaXmJmaoqOkpaanqKmqsrO0tba3uLm6wsPExcbHyMnK0tPU1dbX2Nna4uPk5ebn6Onq8vP0
9fb3+Pn6/9oADAMBAAIRAxEAPwDxWJWt2aQHjpuUg1ZgkmmYAI77vTNNiZJzsjgVRjJ6npXa+F7R
Gj3GMBiegrmq1OVXaN6NJzdk9CXQvD6SRLJOpDN/CR/Ou/0yzt4LdovJXkcnFYRv4tKcLKjbjwoC
E5/IVa07xM11qJtxbZjyVLqjIyMOzBh+orgbcveZ22UVyo4LxRYx6b4gcW8ZAOZTjsP8ivf/AIca
hPf+D7Zpjny/kRiTll/H3yPwryvXtG/tSe61rMi24gNpbGNcmaViRwOu3LgH68cAmvV/Amntp/h2
KAxhFwpXDZ3DAAP4gA/jXTTe1zkqW1PmLTrXG8Nw+cAAg8fh9a7LRwbRU+lchpszfaUOwBccYHWu
7tY0lhUr6VliG76nXheWx0iCG/iUMuHHRu4qxb6dbJI6rgsysrseSSfXNZtlIIQpZtoHc1W1O6k0
11vrS+MiGZVMAwQSx7nBIHBrCLuzWaR3mg+HtNvrK0eNYvLgkIbapQlxkZIzweW4GMFmOATXdKio
AFUAAYAFc5o1nD5Fo+xPNDmVmRQu4kHk4+v+NdKOgFehTWh5k3qfHGmusg8pmEco+6D3rpNI1gK3
kTnaw4rnLV4VuWQDKAgAsevHOKtaraI1rLcW8pMgKlFGQRWdSKlKz6m1ObjG66HpdlHFdQggowP9
7kVzF8+kt4phtvtkKeXI0UnlIQq8jLMQOuSR/wAB7d+ItNc1a2ZoUvXiGMHdjj9Kms7sxQSlYd7s
4JcAlyeeQfrg8+3pS+ruCY3iFKyR9M/D+Rf+Efii4ZgzfPuzuG44A9gMDiuwFeI/DTxjFp1h9k1H
au+QkXEkm3AOMLgj1z37+2a9ntbpLmEOOCe2QfxB6Ee9aU2rct9jCotbnxlnFmjDhgeo69a0UJMF
uxJJK8miinMqBpz28JSOQxRlyB820Z/OoZQASQOQBg96KKzjsEt2VkuZk1GKVZWDk7SwPUYPB9a9
m+Hc8sTLEjkRTWzSvGeV3h8AgdAcE9OtFFRP4kXD4Gf/2Q==

--Multipart=_Sun__30_Mar_2008_17_37_54_+0200_rnHSPKZ7sh0eKFPA
Content-Type: image/jpeg;
 name="img2.JPG"
Content-Disposition: attachment;
 filename="img2.JPG"
Content-Transfer-Encoding: base64
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==

--Multipart=_Sun__30_Mar_2008_17_37_54_+0200_rnHSPKZ7sh0eKFPA--


















Return-Path: <kkkgjh@orange.fr>
Delivery-Date: Sun, 30 Mar 2008 17:28:44 +0200
Received: from smtp20.orange.fr (smtp20.orange.fr [80.12.242.27])
	by mx.kundenserver.de (node=mxeu21) with ESMTP (Nemesis)
	id 0ML4Q0-1JfzSc1VJ4-0003T9 for kkun@ingeniumconseil.fr; Sun, 30 Mar 2008 17:28:44 +0200
Received: from me-wanadoo.net (localhost [127.0.0.1])
	by mwinf2009.orange.fr (SMTP Server) with ESMTP id 2FC3F1C0008D
	for <b.massot@ingeniumconseil.fr>; Sun, 30 Mar 2008 17:28:42 +0200 (CEST)
Received: from andre-qg2jfgoj (AMarseille-151-1-58-53.w82-122.abo.wanadoo.fr [82.122.74.53])
	by mwinf2009.orange.fr (SMTP Server) with ESMTP id 1FE5D1C00085
	for <b.massot@ingeniumconseil.fr>; Sun, 30 Mar 2008 17:28:42 +0200 (CEST)
X-ME-UUID: 20080330152842130.1FE5D1C00085@mwinf2009.orange.fr
From: bert <kjkjgk@orange.fr>
To: burt <kkun@ingeniumconseil.fr>
SUBJECT: pice jointe
MIME-Version: 1.0
CONTENT-TYPE: multipart/mixed;
	boundary="BOUNDARYALT"
X-MAILER: bert-1.0
Message-Id: <20080330152842.1FE5D1C00085@mwinf2009.orange.fr>
Date: Sun, 30 Mar 2008 17:28:42 +0200 (CEST)
Envelope-To: kgkg@ingeniumconseil.fr

This is a multi-part message in MIME format.

--BOUNDARYALT
Content-Type: text/plain;
	Charset="iso-8859-1"
Content-Transfer-Encoding: 7bit

Ceci est le texte
--BOUNDARYALT
Content-Type: image/jpeg;
	name="img.JPG"
Content-Transfer-Encoding: base64
Content-Disposition: attachment
	filename="img.JPG"

/9j/4AAQSkZJRgABAQEAYABgAAD/4QAWRXhpZgAASUkqAAgAAAAAAAAAAAD/2wBDAAgGBgcGBQgH
BwcJCQgKDBQNDAsLDBkSEw8UHRofHh0aHBwgJC4nICIsIxwcKDcpLDAxNDQ0Hyc5PTgyPC4zNDL/
2wBDAQkJCQwLDBgNDRgyIRwhMjIyMjIyMjIyMjIyMjIyMjIyMjIyMjIyMjIyMjIyMjIyMjIyMjIy
MjIyMjIyMjIyMjL/wAARCAAzAC4DASIAAhEBAxEB/8QAHwAAAQUBAQEBAQEAAAAAAAAAAAECAwQF
BgcICQoL/8QAtRAAAgEDAwIEAwUFBAQAAAF9AQIDAAQRBRIhMUEGE1FhByJxFDKBkaEII0KxwRVS
0fAkM2JyggkKFhcYGRolJicoKSo0NTY3ODk6Q0RFRkdISUpTVFVWV1hZWmNkZWZnaGlqc3R1dnd4
eXqDhIWGh4iJipKTlJWWl5iZmqKjpKWmp6ipqrKztLW2t7i5usLDxMXGx8jJytLT1NXW19jZ2uHi
4+Tl5ufo6erx8vP09fb3+Pn6/8QAHwEAAwEBAQEBAQEBAQAAAAAAAAECAwQFBgcICQoL/8QAtREA
AgECBAQDBAcFBAQAAQJ3AAECAxEEBSExBhJBUQdhcRMiMoEIFEKRobHBCSMzUvAVYnLRChYkNOEl
8RcYGRomJygpKjU2Nzg5OkNERUZHSElKU1RVVldYWVpjZGVmZ2hpanN0dXZ3eHl6goOEhYaHiImK
kpOUlZaXmJmaoqOkpaanqKmqsrO0tba3uLm6wsPExcbHyMnK0tPU1dbX2Nna4uPk5ebn6Onq8vP0
9fb3+Pn6/9oADAMBAAIRAxEAPwDxWJWt2aQHjpuUg1ZgkmmYAI77vTNNiZJzsjgVRjJ6npXa+F7R
Gj3GMBiegrmq1OVXaN6NJzdk9CXQvD6SRLJOpDN/CR/Ou/0yzt4LdovJXkcnFYRv4tKcLKjbjwoC
E5/IVa07xM11qJtxbZjyVLqjIyMOzBh+orgbcveZ22UVyo4LxRYx6b4gcW8ZAOZTjsP8ivf/AIca
hPf+D7Zpjny/kRiTll/H3yPwryvXtG/tSe61rMi24gNpbGNcmaViRwOu3LgH68cAmvV/Amntp/h2
KAxhFwpXDZ3DAAP4gA/jXTTe1zkqW1PmLTrXG8Nw+cAAg8fh9a7LRwbRU+lchpszfaUOwBccYHWu
7tY0lhUr6VliG76nXheWx0iCG/iUMuHHRu4qxb6dbJI6rgsysrseSSfXNZtlIIQpZtoHc1W1O6k0
11vrS+MiGZVMAwQSx7nBIHBrCLuzWaR3mg+HtNvrK0eNYvLgkIbapQlxkZIzweW4GMFmOATXdKio
AFUAAYAFc5o1nD5Fo+xPNDmVmRQu4kHk4+v+NdKOgFehTWh5k3qfHGmusg8pmEco+6D3rpNI1gK3
kTnaw4rnLV4VuWQDKAgAsevHOKtaraI1rLcW8pMgKlFGQRWdSKlKz6m1ObjG66HpdlHFdQggowP9
7kVzF8+kt4phtvtkKeXI0UnlIQq8jLMQOuSR/wAB7d+ItNc1a2ZoUvXiGMHdjj9Kms7sxQSlYd7s
4JcAlyeeQfrg8+3pS+ruCY3iFKyR9M/D+Rf+Efii4ZgzfPuzuG44A9gMDiuwFeI/DTxjFp1h9k1H
au+QkXEkm3AOMLgj1z37+2a9ntbpLmEOOCe2QfxB6Ee9aU2rct9jCotbnxlnFmjDhgeo69a0UJMF
uxJJK8miinMqBpz28JSOQxRlyB820Z/OoZQASQOQBg96KKzjsEt2VkuZk1GKVZWDk7SwPUYPB9a9
m+Hc8sTLEjkRTWzSvGeV3h8AgdAcE9OtFFRP4kXD4Gf/2

--BOUNDARYALT

*/
