#include <stdio.h>
#include "TCPsocket.h"
#include "base64.h"

int main(int argc, char *argv[])
{
 init_socket();

 SOCKET sk = connection_TCP("smtp.orange.fr", 25);

 lire(sk);

 char buf[255];
 char hostname[32];
 int i;

 gethostname(hostname, 32);
 i = sprintf(buf,"EHLO %s\n", hostname);
 ecrire(sk, buf, i);
 lire(sk);

 //authentification ------------------------------------------------------------
 char *user = "votreadresse@orange.fr";
 char *pass = "pa25su6*4";

 ecrire(sk,"AUTH LOGIN\n",11);
 //il rpond par un 334 "ok envoie ton login encod en base64"
 i = recv(sk, buf, sizeof(buf), 0);
 if (buf[0]!='3' || buf[1]!='3'  || buf[2]!='4')
 {
  printf("** ECHEC AUTH LOGIN **\n");
  return 1;
 }

 char *tmp = (char*)base64_encoder(user);
 i = sprintf(buf,"%s\n", tmp);
 ecrire(sk, buf, i);
 free(tmp); tmp=NULL;
 //il rpond par un 334? envoyer passe
 i = recv(sk, buf, sizeof(buf), 0);
 if (buf[0]!='3' || buf[1]!='3'  || buf[2]!='4')
 {
  printf("** ECHEC AUTH PASS**\n");
  return 2;
 }

 tmp = (char*)base64_encoder(pass);
 i = sprintf(buf,"%s\n", tmp);
 ecrire(sk,buf,i);
 free(tmp);

 //il rpond par un 235? authentifi.
 i = recv(sk, buf, sizeof(buf), 0);
 if (buf[0]=='2' && buf[1]=='3' && buf[2]=='5')
  printf("Authentifi\202");
 else
  printf("** Echec Authentification **");
 //authentification ------------------------------------------------------------


 i = sprintf(buf, "MAIL FROM: <%s>\n", "bert.mas@orange.fr");
 ecrire(sk, buf, i);

 i = sprintf(buf, "RCPT TO: <%s>\n", "katmailer@orange.fr"); 
 ecrire(sk, buf, i);

 ecrire(sk, "DATA\n", 5);

 i = sprintf(buf, "FROM: %s <%s>\n", "bert", "bert.mas@orange.fr"); 
 ecrire(sk, buf, i);

 i = sprintf(buf, "TO: burt <katmailer@orange.fr>\n"); 
 ecrire(sk, buf, i);

 i = sprintf(buf, "SUBJECT: test de pice jointe\n"); 
 ecrire(sk, buf, i);

 i = sprintf(buf, "CONTENT-TYPE: text/plain; charset=iso-8859-1\n");
 ecrire(sk, buf, i);

 envoi_big_paquet(sk, "bijour",6, 100);

 ecrire(sk, "\r\n.\r\n", 5);
 lire(sk);

 closesocket(sk);

 printf("Fin\n");
 getchar();
 return 0;
}
