/*
 Envoie un email au format HTML, mais affiche un texte
 si le client mail a le HTML dsactiv.
*/

#include <stdio.h>
#include "TCPsocket.h"

int main(int argc, char *argv[])
{
 init_socket();

 SOCKET sk = connection_TCP("smtp.orange.fr", 25);

 lire(sk);

 char buf[255];
 char hostname[32];
 int i;

 gethostname(hostname, 32);
 i = sprintf(buf,"EHLO %s\n", hostname);
 ecrire(sk, buf, i);
 lire(sk);
 
 i = sprintf(buf, "MAIL FROM: <%s>\n", "bert.mas@orange.fr");
 ecrire(sk, buf, i);

 i = sprintf(buf, "RCPT TO: <%s>\n", "b.masta@ingeniumconseil.fr"); 
 ecrire(sk, buf, i);

 ecrire(sk, "DATA\n", 5);

 i = sprintf(buf, "FROM: %s <%s>\n", "bert", "bert.mas@orange.fr"); 
 ecrire(sk, buf, i);

 i = sprintf(buf, "TO: burt <b.masta@ingeniumconseil.fr>\n"); 
 ecrire(sk, buf, i);

 i = sprintf(buf, "SUBJECT: email HTML + texte alternatif\n"); 
 ecrire(sk, buf, i);

 //le texte alternatif
 i = sprintf(buf,  "CONTENT-TYPE: multipart/alternative;\n"
					"	boundary=\"BOUNDARYALT\"\n\n"
					"--BOUNDARYALT\n"
					"Content-Type: text/plain; Charset=\"iso-8859-1\"\n"
					"Content-Transfer-Encoding: 7bit\n");
 ecrire(sk, buf, i);

 //message au format texte brut
 envoi_big_paquet(sk, "Ceci est le texte alternatif",28, 0);

 //le texte HTML
 i = sprintf(buf,  "\n\n--BOUNDARYALT\n"
					"Content-Type: text/html; Charset=\"iso8859-1\"\n"
					"Content-Transfer-Encoding: 7bit\n");
 ecrire(sk, buf, i);

 //message au format HTML
 envoi_big_paquet(sk, "Bonjour <b>toi</b>",18, 0);
  
 ecrire(sk, "\n--BOUNDARYALT\n", 15);

 ecrire(sk, "\r\n.\r\n", 5);
 //lire(sk);

 closesocket(sk);

 //getchar();
 return 0;
}
