#ifndef BXBASE64
#define BXBASE64

#ifdef WIN32
#include <windows.h>
#endif

#include <stdio.h>

typedef struct {
  FILE *hInput;
  FILE *hOutput;
  HWND hWnd;
} BASE64_FILES, *PBASE64_FILES;


static const char cb64[]="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";
static const char cd64[]="|$$$}rstuvwxyz{$$$$$$$>?@ABCDEFGHIJKLMNOPQRSTUVW$$$$$$XYZ[\\]^_`abcdefghijklmnopq";

char* base64_encoder(char *input);
void encode_b64_block( unsigned char in[3], unsigned char out[4], int len);

unsigned char *encode_b64_file(char *fic, long *taille);
char *bxwrap_to_char(char *s, long taille, long *dsttaille, int width);


char* base64_decoder(char *input);
void decode_b64_block( unsigned char in[4], unsigned char out[3]);

#endif
